import type { Store as RefluxStore } from 'reflux';
import type { Store as ReduxStore } from 'redux';
import EventEmitter from 'eventemitter3';
import type { ReactReduxContext } from 'react-redux';
export type Store = (ReduxStore | Partial<RefluxStore>) & {
    onActivated?: (appRegistry: AppRegistry) => void;
};
export type RefluxActions = Record<string, any>;
export declare function isReduxStore(store: Store): store is ReduxStore;
export interface Plugin {
    store: Store;
    context?: typeof ReactReduxContext;
    actions?: RefluxActions;
    deactivate: () => void;
}
export declare class AppRegistry {
    _emitter: EventEmitter;
    plugins: Record<string, Plugin>;
    constructor();
    static get AppRegistry(): typeof AppRegistry;
    deregisterPlugin(name: string): this;
    getPlugin(name: string): Plugin | undefined;
    registerPlugin(name: string, plugin: Plugin): this;
    deactivate(): void;
    addListener(eventName: string, listener: (...args: any[]) => void): this;
    emit(eventName: string, ...args: any[]): boolean;
    eventNames(): string[];
    listenerCount(eventName: string): number;
    listeners(eventName: string): ((...args: any[]) => void)[];
    on(eventName: string, listener: (...args: any[]) => void): this;
    once(eventName: string, listener: (...args: any[]) => void): this;
    removeListener(eventName: string, listener: (...args: any[]) => void): this;
    removeAllListeners(eventName: string): this;
}
export declare const globalAppRegistry: Readonly<AppRegistry>;
//# sourceMappingURL=app-registry.d.ts.map