"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useLocalAppRegistry = exports.useGlobalAppRegistry = exports.AppRegistryProvider = exports.GlobalAppRegistryContext = void 0;
const react_1 = __importStar(require("react"));
const app_registry_1 = require("./app-registry");
exports.GlobalAppRegistryContext = (0, react_1.createContext)(app_registry_1.globalAppRegistry);
const LocalAppRegistryContext = (0, react_1.createContext)(null);
function AppRegistryProvider({ children, ...props }) {
    const initialPropsRef = (0, react_1.useRef)(props);
    const { localAppRegistry: initialLocalAppRegistry, deactivateOnUnmount = true, } = initialPropsRef.current;
    const globalAppRegistry = useGlobalAppRegistry();
    const isTopLevelProvider = (0, react_1.useContext)(LocalAppRegistryContext) === null;
    const [localAppRegistry] = (0, react_1.useState)(() => {
        return (initialLocalAppRegistry ??
            (isTopLevelProvider ? globalAppRegistry : new app_registry_1.AppRegistry()));
    });
    (0, react_1.useEffect)(() => {
        const shouldDeactivate = initialLocalAppRegistry
            ? deactivateOnUnmount
            : true;
        return () => {
            if (shouldDeactivate) {
                localAppRegistry.deactivate();
            }
        };
    }, [localAppRegistry, initialLocalAppRegistry, deactivateOnUnmount]);
    return (react_1.default.createElement(exports.GlobalAppRegistryContext.Provider, { value: globalAppRegistry },
        react_1.default.createElement(LocalAppRegistryContext.Provider, { value: localAppRegistry }, children)));
}
exports.AppRegistryProvider = AppRegistryProvider;
function useGlobalAppRegistry() {
    return (0, react_1.useContext)(exports.GlobalAppRegistryContext);
}
exports.useGlobalAppRegistry = useGlobalAppRegistry;
function useLocalAppRegistry() {
    const appRegistry = (0, react_1.useContext)(LocalAppRegistryContext);
    if (!appRegistry) {
        throw new Error(`No local AppRegistry registered within this context`);
    }
    return appRegistry;
}
exports.useLocalAppRegistry = useLocalAppRegistry;
//# sourceMappingURL=react-context.js.map