import React from 'react';
import type { Plugin } from './app-registry';
import { AppRegistry } from './app-registry';
declare class ActivateHelpersImpl {
    private cleanupFns;
    private deactivateController;
    constructor();
    get signal(): AbortSignal;
    on: (emitter: {
        on(evt: string, fn: (...args: any) => any): any;
        removeListener(evt: string, fn: (...args: any) => any): any;
    }, evt: string, fn: (...args: any) => any) => void;
    addCleanup: (fn: () => void) => void;
    cleanup: () => void;
}
export type ActivateHelpers = Pick<ActivateHelpersImpl, 'on' | 'addCleanup' | 'cleanup' | 'signal'>;
export declare function createActivateHelpers(): ActivateHelpers;
type Registries = {
    globalAppRegistry: AppRegistry;
    localAppRegistry: AppRegistry;
};
type Services<S extends Record<string, () => unknown>> = {
    [SvcName in keyof S]: ReturnType<S[SvcName]>;
};
export type HadronPluginConfig<T, S extends Record<string, () => unknown>> = {
    name: string;
    component: React.ComponentType<T>;
    activate: (initialProps: T, services: Registries & Services<S>, helpers: ActivateHelpers) => Plugin;
};
type MockOptions = {
    pluginName: string;
    mockedEnvironment: boolean;
    mockServices: Record<string, unknown>;
    disableChildPluginRendering: boolean;
};
export declare function createServiceLocator<T extends (this: any, ...args: any[]) => any>(fn: T, name?: string): T;
export declare function createServiceProvider<T extends React.FunctionComponent>(fn: T): T;
export type HadronPluginComponent<T, S extends Record<string, () => unknown>> = React.FunctionComponent<T> & {
    displayName: string;
    useActivate(props: T): void;
    withMockServices(mocks: Partial<Registries & Services<S>>, options?: Partial<Pick<MockOptions, 'disableChildPluginRendering'>>): React.FunctionComponent<T>;
};
export declare function registerHadronPlugin<T, S extends Record<string, () => unknown>>(config: HadronPluginConfig<T, S>, services?: S): HadronPluginComponent<T, S>;
export {};
//# sourceMappingURL=register-plugin.d.ts.map